# The Complete Coding Interview Guide in Java	 

<a href="https://www.packtpub.com/product/the-complete-coding-interview-guide-in-java/9781839212062"><img src="https://static.packt-cdn.com/products/9781839212062/cover/smaller" alt="The Complete Coding Interview Guide in Java " height="256px" align="right"></a>

This is the code repository for [The Complete Coding Interview Guide in Java ](https://www.packtpub.com/product/the-complete-coding-interview-guide-in-java/9781839212062), published by Packt.

**An effective guide for aspiring Java developers to ace their programming interviews**

## What is this book about?
Java is one of the most sought-after programming languages in the job market, but cracking the coding interview in this challenging economy might not be easy. This comprehensive guide will help you to tackle various challenges faced in a coding job interview and avoid common interview mistakes, and will ultimately guide you toward landing your job as a Java developer.

This book covers the following exciting features:
Solve the most popular Java coding problems efficiently
Tackle challenging algorithms that will help you develop robust and fast logic
Practice answering commonly asked non-technical interview questions that can make the difference between a pass and a fail
Get an overall picture of prospective employers' expectations from a Java developer
Solve various concurrent programming, functional programming, and unit testing problems

If you feel this book is for you, get your [copy](https://www.packtpub.com/product/the-complete-coding-interview-guide-in-java/9781839212062) today!

## Instructions and Navigations
All of the code is organized into folders. For example, Chapter02.

The code will look like the following:
```
"@RunWith(JUnitPlatform.class)
public class NestedTest {
	private static final Logger log = Logger.getLogger(NestedTest.class.getName());,
```

**Following is what you need for this book:**
This book is for students, programmers, and employees who want to be invited to and pass interviews given by top companies. The book assumes high school mathematics and basic programming knowledge.	


With the following software and hardware list you can run all code files present in the book (Chapter 1-19).
### Software and Hardware List
| No | Software required | OS required |
| -------- | ------------------------------------ | ----------------------------------- |
| 1 | JDK 8+ | Windows, Mac OS X, and Linux (Any) |
| 2 | IDE (Eclipse, IntelliJ IDEA) | Windows, Mac OS X, and Linux (Any) |


We also provide a PDF file that has color images of the screenshots/diagrams used in this book. [Click here to download it](https://static.packt-cdn.com/downloads/9781839212062_ColorImages.pdf).

### Related products
* Java Coding Problems  [[Packt]](https://www.packtpub.com/product/java-coding-problems/9781789801415) [[Amazon]](https://www.amazon.com/Java-Coding-Problems-Programming-real-world-ebook/dp/B07Y9BPV4W)

* Learn Java 12 Programming  [[Packt]](https://www.packtpub.com/product/learn-java-12-programming/9781789957051) [[Amazon]](https://www.amazon.com/Learn-Java-Programming-step-step-ebook/dp/B07PJRVZLG)

## Get to Know the Author
**Anghel Leonard** is a chief technology strategist with more than 20 years’ experience in the Java ecosystem. In his daily work, he is focused on architecting and developing Java-distributed applications that empower robust architectures, clean code, and high performance. He is also passionate about coaching, mentoring, and technical leadership.

### Suggestions and Feedback
[Click here](https://docs.google.com/forms/d/e/1FAIpQLSdy7dATC6QmEL81FIUuymZ0Wy9vH1jHkvpY57OiMeKGqib_Ow/viewform) if you have any feedback or suggestions.


